setInfos(9, "theEdger-cum", "An edging script with pictures", "NIFOC99", "v2.1", 0x00FF00, "en", ["edging", "exhibition", "formale", "internet"]);
// v0.1 first release
// v0.2 very minor corrections
// v0.3 sounds added
// v0.4 simplified voting, reduced calls to server (watch) changes to array lengths (go and stop) don't throw women out (not really fair!)
// v1.0 check for blank pictures, added quit to watch, first stable version
// v1.1 allow for android in picBlank (theEdger.groovy)
// v1.2 check for blank pictures
// v1.3 changes to stored pics (codeB) to prevent multiple posting
// v1.4 no changes here
// v2.1 title added, server access rewritten, file-based messages, progress bar

//Define messages, times in seconds for the various phases
def PicNumCode = [], PicKeyCode = [], PlCodeCode = [], PlNameCode = []
def NumberPicsText = [ "one picture", "two pictures" ]

def Title = "<h1 style='font-size:140%;'>theEdger</h1><p>"

//Get basic info about player

def PlayerName = loadString("intro.name")
def PlayerCode = loadInteger("theEdger.PlayerCode")
if(PlayerCode==null) {
	PlayerCode = getRandom(1000000)
	save("theEdger.PlayerCode",PlayerCode)
	}

def NumberStarts = loadInteger("theEdger.NumberStarts")?: 0
def FileStart = loadString("theEdger.FileStart")
def FileMax = loadInteger("theEdger.FileMax")

def PicCodeA, PicCodeB, PicCodeBChars, PicNumberB, NumberPics, PicKey, MissLen
int PicNumber

def PicCodeMax = 50

//Closures (functions)########################################################################################

def picBlank = {def  pic -> //checks if picture is blank (all the same colour)--------------------------------

	if (getDataFolder().toLowerCase().contains("android")) {return false} //don't try with android

	def image = javax.imageio.ImageIO.read(new File(pic))
	int width = image.getWidth()
	int height = image.getHeight()
	if(width<90||height<90) {return true} //might as well be blank

	def a = [0, 0, 0, 0 ,0 ,0 ,0 ,0 ,0 ,0]
	def r = [0, 0, 0, 0 ,0 ,0 ,0 ,0 ,0 ,0]
	def g = [0, 0, 0, 0 ,0 ,0 ,0 ,0 ,0 ,0]
	def b = [0, 0, 0, 0 ,0 ,0 ,0 ,0 ,0 ,0]
	def asum = 0; def rsum = 0; def gsum = 0; def bsum = 0
	

	for (def k = 0; k < 10; k++) {
		int x = getRandom(width)
		int y = getRandom(height)
		int p = image.getRGB(x, y)
		a[k] = (p>>24) & 0xff; r[k] = (p>>16) & 0xff; g[k] = (p>>8) & 0xff; b[k] = p & 0xff
		asum = asum+a[k]; rsum = rsum+r[k]; gsum = gsum+g[k]; bsum = bsum+b[k]		
	}
	def aave = asum/10; def rave = rsum/10; def gave = gsum/10; def bave = bsum/10

	def astd = 0; def rstd = 0; def gstd = 0; def bstd = 0

	for (def k = 0; k < 10; k++) {
		astd = astd+(a[k]-aave)*(a[k]-aave)
		rstd = rstd+(r[k]-rave)*(r[k]-rave)
		gstd = gstd+(g[k]-gave)*(g[k]-gave)
		bstd = bstd+(b[k]-bave)*(b[k]-bave)
	}
	astd = Math.sqrt(astd); rstd = Math.sqrt(rstd); gstd = Math.sqrt(gstd); bstd = Math.sqrt(bstd)

	if(astd<50&&rstd<50&&gstd<50&&bstd<50) {return true}
	else {return false}
}

def getCodes = {C -> //---------------------------------------------------------------------------------------
	def S1 = 0; def S2 = 0; def PList = []
	for(def i=0; i<C.count("|"); i++) {
		S2 = C.indexOf("|", S1)
		PList << C.substring(S1, S2)
		S1 = S2+1
	}
	return PList
}

def makeCode = {def Ltext ->//--------------------------------------------------------------------------------
	def t = ""
	for(def k=0; k<Ltext.size(); k++) {t = t+Ltext[k]+"|"}
	return t		
}

def ProgressBar = {c, t, g ->//-------------------------------------------------------------------------------
	def t1 = t/30
	def t2 = 0
	def t3 = false
	if(getRandom(2)==0) {t3 = true}
	for(def i=0; i<30; i++) {
		t2 = t2+t1
		if(t3&&i>25) {//take picture
			PicCodeB = loadString("theEdger.PicCodeB")//player pictures codes
			PicCodeBChars = PicCodeB.toCharArray()
			PicNumber = PicCodeB.indexOf("0")
			if(PicNumber<0) {PicNumber = getRandom(PicCodeMax)}
			PicCodeA = getImage("")
			if(PicCodeA.indexOf("captured")>=0) {//Check not fake
				save("theEdger.PicCodeA"+PicNumber, PicCodeA)
				save("theEdger.LatestPic", PicCodeA)
				PicCodeBChars[PicNumber]="1"
				PicCodeB = String.valueOf(PicCodeBChars)
				save("theEdger.PicCodeB", PicCodeB)
				t3 = false
			}
		}
		def m = "<font color='blue'>"
		if(!g) {m = m+"I'm not telling you how long! <b>Just wait!</b></font>"}
		else {
			for(def j=0; j<30; j++) {
				if(j==i+1) {m = m+"</font><font color='white'>"}
				m = m+"█"
			}
			m = m+"</font>"
		}
		show(c+"<p style='font-size:80%;text-align:center;'>"+m+"</p>")
		wait(t1)
	}
	return
}

def SendPic = {A ->//-----------------------------------------------------------------------------------

	MissLen = 0
	PicNumCode = getCodes(receiveString("theEdger.PicNumText")?: "")
	if(PicNumCode!=[]) {MissLen = PicCodeMax-PicNumCode.size()}
	else {MissLen = PicCodeMax}
	if(MissLen>0) {for(def j=0; j<MissLen; j++) {PicNumCode << "0"}}
	PicKeyCode = getCodes(receiveString("theEdger.PicKeyText")?: "")
	if(PicKeyCode!=[]) {MissLen = PicCodeMax-PicKeyCode.size()}
	else {MissLen = PicCodeMax}
	if(MissLen>0) {for(def j=0; j<MissLen; j++) {PicKeyCode << ""}}
	PlCodeCode = getCodes(receiveString("theEdger.PlCodeText")?: "")
	if(PlCodeCode!=[]) {MissLen = PicCodeMax-PlCodeCode.size()}
	else {MissLen = PicCodeMax}
	if(MissLen>0) {for(def j=0; j<MissLen; j++) {PlCodeCode << ""}}
	PlNameCode = getCodes(receiveString("theEdger.PlNameText")?: "")
	if(PlNameCode!=[]) {MissLen = PicCodeMax-PlNameCode.size()}
	else {MissLen = PicCodeMax}
	if(MissLen>0) {for(def j=0; j<MissLen; j++) {PlNameCode << ""}}

	PicNumber = PicNumCode.indexOf("0") //Free slot
	if(PicNumber<0) {PicNumber = getRandom(PicCodeMax)} //or random
	PicNumCode[PicNumber] = "3"
	PicKeyCode[PicNumber] = sendImage(A)
	PlCodeCode[PicNumber] = PlayerCode
	PlNameCode[PicNumber] = PlayerName

	send("theEdger.PicNumText", makeCode(PicNumCode))
	send("theEdger.PicKeyText", makeCode(PicKeyCode))
	send("theEdger.PlCodeText", makeCode(PlCodeCode))
	send("theEdger.PlNameText", makeCode(PlNameCode))
			
}

def ShowPic = {
	switch(FileMax) {
		case 0:
			return
		case 1:
			def EdgerPath = getDataFolder().replaceAll("\\\\", "/")+"images/theEdger/user/"
			def EdgerFiles = []
			new File(EdgerPath).eachFile() {file->
				if(file.isFile()&&(file.getAbsolutePath().indexOf(".jpg")>0||
					file.getAbsolutePath().indexOf(".jpeg")>0||
					file.getAbsolutePath().indexOf(".gif")>0||
					file.getAbsolutePath().indexOf(".png")>0)) {
					EdgerFiles << file.getAbsolutePath()
				}
			}
			setImage(EdgerFiles[getRandom(EdgerFiles.size)])
			return
		case 2:
			setImage(loadString("theEdger.LatestPic"))
			return
	}
}

//End of closures (functions)---------------------------------------------------------------------------------

//Start ######################################################################################################

def CumLines = new File("scripts/theEdger/theEdger-cum.txt").readLines()
def CumList = getCodes(CumLines[getRandom(CumLines.size)])
//message|time|min time|soundfile|

def CumMessage = "<p style='font-size:120%;'>"+CumList[0]+"</p>"

ShowPic()

if(CumList[3]!="-1") {playBackgroundSound("theEdger/"+FileStart+"_"+CumList[3]+".mp3")}
ProgressBar(Title+CumMessage, CumList[1] as Integer, true)

//Equalise number of finishes and starts

def NumberFinishes = NumberStarts
save("theEdger.NumberFinishes", NumberFinishes)

NumberPics = getRandom(2)+1

setImage("theEdger/theEdger001.jpg")
show(Title+"<p style='font-size:120%;'><b style='color:red;'>STOP</b> if you haven't cum, tough luck.</p><p>"+
	"Try again. You might get lucky!<p><p>"+
	"As you did get the chance to cum, you owe "+NumberPicsText[NumberPics-1]+"<p><p>"+
	"<b>Wait</b> while the debt is paid, then you can get back to the start.")
playSound("theEdger/"+FileStart+"_2.mp3")
wait(1)

//Pictures to be released
if(isConnected()) {
	for(def i=0; i<NumberPics; i++) {
		PicCodeB = loadString("theEdger.PicCodeB")
		PicCodeBChars = PicCodeB.toCharArray()
		PicNumberB = PicCodeB.indexOf("1") //A picture
		if(PicNumberB>=0) {//Only if there are pics
			PicCodeA = loadString("theEdger.PicCodeA"+PicNumberB)?: "temp"

			SendPic(PicCodeA)

			PicCodeBChars[PicNumberB] = "0"
			PicCodeB = String.valueOf(PicCodeBChars)
			save("theEdger.PicCodeB", PicCodeB)
			save("theEdger.PicCodeA"+PicNumberB, null)
		}
	}
}


return "theEdger.groovy"

// This script, from https://ss.deviatenow.com, is the copyright of the author
// copyright restrictions will be relaxed on future (stable) versions
